/***************************************************************************
;
;    This module is part of the BiPOM developer image for CloudGate Monnit
;    support. All the information in this source file and other source files
;    in the same developer image are copyrighted property of BiPOM Electronics.
;    The source files and the contained information in the source files are
;    confidential and should not be disclosed to anybody other than BiPOM,
;    Option and Monnit software developers, and only to those that have a need to
;    know.
;
;    BiPOM Electronics disclaims all warranties, express or implied warranties
;    of merchantability and fitness for a particular purpose. In no event shall
;    BiPOM Electronics be liable for any indirect, special, incidental or
;    consequential damages in connection  with or arising from the use of this
;    program.
;
;    Please e-mail any questions and suggestions to tech@bipom.com
;
***************************************************************************/

#ifndef _BIPOM_ERRORS_
#define _BIPOM_ERRORS_

#ifdef __cplusplus
extern "C"{
#endif 

/***************************************************************************/
#define E_USR(x)		(10000+x)
#define E_THRD(x)		(100+x)
#define E_SP(x)			(200+x)
#define E_SRV(x)		(300+x)
#define E_WRTU(x)		(400+x)
#define E_PROTO(x)		(500+x)
#define E_UTILS(x)		(600+x)
#define E_TCP(x)		(700+x)
#define E_HTTP(x)		(800+x)
#define E_SSL(x)		(900+x)
#define E_SMTP(x)		(1000+x)
// IMPORTANT: Do not use 1400. It is already reserved

/***************************************************************************/
/* Thread Subsystem Errors */
#define E_THRD_NULL_ARG								E_THRD(1)
#define E_THRD_ARG_OUT_OF_RANGE						E_THRD(2)
#define E_THRD_NOT_INIT								E_THRD(3)
#define E_THRD_ALREADY_INIT							E_THRD(4)
#define E_THRD_BAD_FUNC								E_THRD(5)
#define E_THRD_NOT_STARTED							E_THRD(6)
#define E_THRD_ALREADY_STARTED						E_THRD(7)
#define E_THRD_START_FAILED							E_THRD(8)
#define E_THRD_JOIN_FAILED							E_THRD(9)
#define E_THRD_CANCEL_FAILED						E_THRD(10)
#define E_THRD_BAD_PARAMS							E_THRD(11)
#define E_THRD_BAD_OWNER_POINTER					E_THRD(12)

/***************************************************************************/
/* Serial Port Subsystem Errors */
#define E_SP_NULL_ARG								E_SP(1)
#define E_SP_ARG_OUT_OF_RANGE						E_SP(2)
#define E_SP_ALREADY_OPENED							E_SP(3)
#define E_SP_OPEN_FAILED							E_SP(4)
#define E_SP_INVALID								E_SP(5)
#define E_SP_READ_TIMEOUT							E_SP(6)
#define E_SP_READ_FAILED							E_SP(7)
#define E_SP_WRITE_TIMEOUT							E_SP(8)
#define E_SP_WRITE_FAILED							E_SP(9)
#define E_SP_SET_LINE_STATE							E_SP(10)
#define E_SP_GET_LINE_STATE							E_SP(11)

/***************************************************************************/
/* WRTU Service Subsystem Errors */
#define E_SRV_NULL_ARG								E_SRV(1)
#define E_SRV_NOT_INIT								E_SRV(2)
#define E_SRV_OUT_OF_RANGE							E_SRV(3)
#define E_SRV_RX_BUFFER_EMPTY						E_SRV(4)
#define E_SRV_TX_BUFFER_EMPTY						E_SRV(5)
#define E_SRV_READ_TIMEOUT							E_SRV(6)
#define E_SRV_CANCELLED								E_SRV(7)

/***************************************************************************/
/* WRTU Protocol Subsystem Errors */
#define E_WRTU_NULL_ARG								E_WRTU(1)
#define E_WRTU_NOT_CONNECTED						E_WRTU(2)

/***************************************************************************/
/* Modbus Subsystem Errors */
#define E_PROTO_NULL_ARG							E_PROTO(1)
#define E_PROTO_INVALID_ADDR						E_PROTO(2)
#define E_PROTO_EXCEPTION							E_PROTO(3)
#define E_PROTO_INVALID_RESPONSE					E_PROTO(4)
#define E_PROTO_INVALID_RTU							E_PROTO(5)
#define E_PROTO_INVALID_FUNCTION					E_PROTO(6)
#define E_PROTO_INVALID_CRC16						E_PROTO(7)
#define E_PROTO_REQUEST_TOO_LONG					E_PROTO(8)
#define E_PROTO_CMD_RETURN_ERROR					E_PROTO(9)
#define E_PROTO_PARSE_DATA_FAILED					E_PROTO(10)
#define E_PROTO_RESPONSE_STATUS_BAD					E_PROTO(11)

/***************************************************************************/
/* Utils Subsystem Errors */
#define E_UTILS_ALREADY_EXISTS						E_UTILS(1)
#define E_UTILS_CREATE_DIR_FAILED					E_UTILS(2)

/***************************************************************************/
/* TCP Sockets Subsystem Errors */
#define E_TCP_CREATE_SOCKET						E_TCP(1)
#define E_TCP_SETOPT_FAILED						E_TCP(2)
#define E_TCP_GETOPT_FAILED						E_TCP(3)
#define E_TCP_FCNTL_SET_FAILED					E_TCP(4)
#define E_TCP_FCNTL_GET_FAILED					E_TCP(5)
#define E_TCP_IP_ADDR_INVALID					E_TCP(6)
#define E_TCP_BIND_FAILED						E_TCP(7)
#define E_TCP_LISTEN_FAILED						E_TCP(8)
#define E_TCP_SOCKET_INVALID					E_TCP(9)
#define E_TCP_READ_TIMEOUT						E_TCP(10)
#define E_TCP_READ_ERROR						E_TCP(11)
#define E_TCP_READ_NOT_COMPLETED				E_TCP(12)
#define E_TCP_WRITE_ERROR						E_TCP(13)
#define E_TCP_PEER_CLOSE_CONNECTION				E_TCP(14)
#define E_TCP_GET_HOST_INFO						E_TCP(15)
#define E_TCP_CONNECT_FAILED					E_TCP(16)
#define E_TCP_SELECT_FAILED						E_TCP(17)
#define E_TCP_CONNECT_TIMEOUT					E_TCP(18)
#define E_TCP_NOT_CONNECTED						E_TCP(19)
#define E_TCP_SOCKET_FORBIDDEN					E_TCP(20)
#define E_TCP_SOCKET_NOT_OPENED					E_TCP(21)
#define E_TCP_SOCKET_NOT_CONNECTED				E_TCP(22)
#define E_TCP_NULL_ARG							E_TCP(23)
#define E_TCP_IOCNTL_GET_BYTES_FAILED			E_TCP(24)

/***************************************************************************/
/* HTTP Subsystem Errors */
#define E_HTTP_BAD_RESPONSE						E_HTTP(1)
#define E_HTTP_FAILED_ATTACH_FILE				E_HTTP(2)
#define E_HTTP_FAILED_TO_READ_FILE				E_HTTP(3)
#define E_HTTP_MISSING_CONTENT_LENGTH			E_HTTP(4)
#define E_HTTP_TOO_BIG_RESPONSE					E_HTTP(5)

/***************************************************************************/
/* SSL Subsystem Errors */
#define E_SSL_INIT_CTX_FAILED					E_SSL(1)
#define E_SSL_ATTACH_SOCKET_FAILED				E_SSL(2)
#define E_SSL_WRITE_FAILED						E_SSL(3)
#define E_SSL_READ_FAILED						E_SSL(4)

// ***********************************************************************************************/
#define E_SMTP_INVALID_OBJECT					E_SMTP(1)
#define E_SMTP_INVALID_SOCKET					E_SMTP(2)
#define E_SMTP_SERVER_NOT_READY					E_SMTP(3)
#define E_SMTP_UNDEF_STATUS						E_SMTP(4)	
#define E_SMTP_COMMAND_EHLO						E_SMTP(5)
#define E_SMTP_COMMAND_AUTH_LOGIN				E_SMTP(6)
#define E_SMTP_BAD_LOGIN_PASS					E_SMTP(7)
#define E_SMTP_COMMAND_MAIL_FROM				E_SMTP(8)
#define E_SMTP_COMMAND_RCPT_TO					E_SMTP(9)
#define E_SMTP_COMMAND_DATA						E_SMTP(10)
#define E_SMTP_COMMAND_QUIT						E_SMTP(11)
#define E_SMTP_UNDEF_LOGIN						E_SMTP(12)
#define E_SMTP_UNDEF_PASSWORD					E_SMTP(13)
#define E_SMTP_UNDEF_MAIL_FROM					E_SMTP(14)
#define E_SMTP_UNDEF_RECIPIENTS					E_SMTP(15)
#define E_SMTP_NOMORE_RECIPIENTS				E_SMTP(16)
		
/***************************************************************************/
void WRTU_GetErrDescription(int ec, char *pDestBuf);
		
#ifdef __cplusplus
}
#endif

#endif
