/***************************************************************************
;
;    This module is part of the BiPOM developer image for CloudGate Monnit
;    support. All the information in this source file and other source files
;    in the same developer image are copyrighted property of BiPOM Electronics.
;    The source files and the contained information in the source files are
;    confidential and should not be disclosed to anybody other than BiPOM,
;    Option and Monnit software developers, and only to those that have a need to
;    know.
;
;    BiPOM Electronics disclaims all warranties, express or implied warranties
;    of merchantability and fitness for a particular purpose. In no event shall
;    BiPOM Electronics be liable for any indirect, special, incidental or
;    consequential damages in connection  with or arising from the use of this
;    program.
;
;    Please e-mail any questions and suggestions to tech@bipom.com
;
***************************************************************************/

#ifndef _BIPOM_HTTP_REQUEST_
#define _BIPOM_HTTP_REQUEST_

#include "ssl.h"
#include "http_response.h"

#ifdef __cplusplus
extern "C"{
#endif 

	/***************************************************************************/
	#define HTTP_REQUST_SHEMA_LEN   16
	#define HTTP_REQUST_HOST_LEN	64	
	#define HTTP_REQUST_URL_LEN		128
	#define HTTP_FILE_PATH_LEN		128
	#define BIPOM_HTTP_BUFFER_SIZE	512

	/***************************************************************************/
	typedef struct _bipom_http_request
	{
		char	Host[HTTP_REQUST_HOST_LEN];
		char	Url[HTTP_REQUST_URL_LEN];
		int		Port;
		int		UseSsl;

		char	AtatchedFilePath[HTTP_FILE_PATH_LEN];
		Ssl		SslInfo;

	} HttpRequest;

	/***************************************************************************/
	int HTTP_REQUEST_Init(HttpRequest *pHttpRequest, char *pHost, char *pUrl, int port, int useSsl);
	int HTTP_REQUEST_AttachFile(HttpRequest *pHttpRequest, char *pFilePath);
	int HTTP_REQUEST_Send(HttpRequest *pHttpRequest, HttpResponse *pHttpResponse);
	int HTTP_REQUEST_ParseUrl(const char *pUrl, char *pSchema, char *pHost, char *pPath);

#ifdef __cplusplus
}
#endif

#endif