/***************************************************************************
;
;    This module is part of the BiPOM developer image for CloudGate Monnit
;    support. All the information in this source file and other source files
;    in the same developer image are copyrighted property of BiPOM Electronics.
;    The source files and the contained information in the source files are
;    confidential and should not be disclosed to anybody other than BiPOM,
;    Option and Monnit software developers, and only to those that have a need to
;    know.
;
;    BiPOM Electronics disclaims all warranties, express or implied warranties
;    of merchantability and fitness for a particular purpose. In no event shall
;    BiPOM Electronics be liable for any indirect, special, incidental or
;    consequential damages in connection  with or arising from the use of this
;    program.
;
;    Please e-mail any questions and suggestions to tech@bipom.com
;
***************************************************************************/

#ifndef _BIPOM_MB_REQUEST_INFO_
#define _BIPOM_MB_REQUEST_INFO_

#ifdef __cplusplus
extern "C"{
#endif 

	/***************************************************************************/
	#define MB_REQUEST_LENTH	2048
	#define MB_RESPONSE_LENTH	2048
	#define MB_MAX_VALUES_COUNT 128

	/***************************************************************************/
	typedef struct _mb_request_info
	{
		char	Rtu;
		char	Func;

		int 	FirstRegAddr;
		int 	NumOfRegisters;
		
		char	RequestData[MB_REQUEST_LENTH];
		int		RequestLength;

		char	ResponseData[MB_RESPONSE_LENTH];
		int		ResponseLength;

		int		Values[MB_MAX_VALUES_COUNT];
		int		ValuesCount;

		int		Pending;
		int		Completed;
		int		Error;

	} ModbusRequestInfo;

#ifdef __cplusplus
}
#endif

#endif