/***************************************************************************
;
;    This module is part of the BiPOM developer image for CloudGate Monnit
;    support. All the information in this source file and other source files
;    in the same developer image are copyrighted property of BiPOM Electronics.
;    The source files and the contained information in the source files are
;    confidential and should not be disclosed to anybody other than BiPOM,
;    Option and Monnit software developers, and only to those that have a need to
;    know.
;
;    BiPOM Electronics disclaims all warranties, express or implied warranties
;    of merchantability and fitness for a particular purpose. In no event shall
;    BiPOM Electronics be liable for any indirect, special, incidental or
;    consequential damages in connection  with or arising from the use of this
;    program.
;
;    Please e-mail any questions and suggestions to tech@bipom.com
;
***************************************************************************/

#ifndef _NMEA_H_
#define _NMEA_H_
//
#define NMEA_MAX_ITEM                    20
#define NMEA_MAX_SYMBOL                  11
#define NMEA_MAX_SATTELITE               12
#define NMEA_MAX_LENGHT                  80
//
#define NMEA_GPS_EMPTY					0	
#define NMEA_GPS_INUSE					1
#define NMEA_GPS_START_CMD    			1
#define NMEA_GPS_END_CMD      			0
//
#define NMEA_NONE              		     255
#define NMEA_GGA               		     0
#define NMEA_GLL               	         1
#define NMEA_GSA               		     2
#define NMEA_GSV               		     3
#define NMEA_RMC               		     4
#define NMEA_VTG               		     5
#define NMEA_ZDA              		     8
//
//GGA
#define NMEA_GGA_HEADER                   0
#define NMEA_GGA_UTC_TIME                 1
#define NMEA_GGA_LATITUDE                 2
#define NMEA_GGA_N_S_INDICATOR            3
#define NMEA_GGA_LONGITUDE                4
#define NMEA_GGA_E_W_INDICATOR            5
#define NMEA_GGA_POSITION_INDICATOR       6
#define NMEA_GGA_SATTELITE_USED           7
#define NMEA_GGA_HDOP                     8
#define NMEA_GGA_MSL_ALTITUDE             9
#define NMEA_GGA_UNITS_1                  10
#define NMEA_GGA_GEOID_SEPARATION         11
#define NMEA_GGA_UNITS_2                  12
#define NMEA_GGA_AGE_OF_DIFF_CORR         13
#define NMEA_GGA_DIFF_REF_STATION_ID      14
//
//GLL
#define NMEA_GLL_HEADER                   0
#define NMEA_GLL_LATITUDE                 1
#define NMEA_GLL_N_S_INDICATOR            2
#define NMEA_GLL_LONGITUDE                3
#define NMEA_GLL_E_W_INDICATOR            4
#define NMEA_GLL_UTC_TIME                 5
#define NMEA_GLL_STATUS                   6
#define NMEA_GLL_MODE                     7
//   
//GSA
#define NMEA_GSA_HEADER                   0
#define NMEA_GSA_MODE_1                   1
#define NMEA_GSA_MODE_2                   2
#define NMEA_GSA_SATELLITE_1              3
#define NMEA_GSA_SATELLITE_2              4
#define NMEA_GSA_SATELLITE_3              5
#define NMEA_GSA_SATELLITE_4              6
#define NMEA_GSA_SATELLITE_5              7
#define NMEA_GSA_SATELLITE_6              8
#define NMEA_GSA_SATELLITE_7              9                
#define NMEA_GSA_SATELLITE_8              10
#define NMEA_GSA_SATELLITE_9              11
#define NMEA_GSA_SATELLITE_10             12
#define NMEA_GSA_SATELLITE_11             13                
#define NMEA_GSA_SATELLITE_12             14
#define NMEA_GSA_PDOP                     15
#define NMEA_GSA_HDOP                     16
#define NMEA_GSA_VDOP                     17                
//
//GSV
#define NMEA_GSV_HEADER                     0
#define NMEA_GSV_NUMBER_OF_MESSAGES         1
#define NMEA_GSV_MESSAGE_NUMBER1            2
#define NMEA_GSV_SATELLITES_IN_VIEW         3
#define NMEA_GSV_SATELLITE_ID_1             4
#define NMEA_GSV_ELEVATION_1                5
#define NMEA_GSV_AZIMUTH_1                  6
#define NMEA_GSV_SNR_1                      7
#define NMEA_GSV_SATELLITE_ID_2             8
#define NMEA_GSV_ELEVATION_2                9
#define NMEA_GSV_AZIMUTH_2                  10
#define NMEA_GSV_SNR_2                      11
#define NMEA_GSV_SATELLITE_ID_3             12
#define NMEA_GSV_ELEVATION_3                13
#define NMEA_GSV_AZIMUTH_3                  14
#define NMEA_GSV_SNR_3                      15
#define NMEA_GSV_SATELLITE_ID_4             16
#define NMEA_GSV_ELEVATION_4                17
#define NMEA_GSV_AZIMUTH_4                  18
#define NMEA_GSV_SNR_4                      19
//              
//RMC
#define NMEA_RMC_HEADER                   	0
#define NMEA_RMC_UTC_TIME                 	1
#define NMEA_RMC_STATUS                   	2
#define NMEA_RMC_LATITUDE                 	3
#define NMEA_RMC_N_S_INDICATOR            	4
#define NMEA_RMC_LONGITUDE                	5
#define NMEA_RMC_E_W_INDICATOR            	6
#define NMEA_RMC_SPEED_OVER_GROUND        	7
#define NMEA_RMC_COURSE_OVER_GROUND       	8
#define NMEA_RMC_DATE                     	9
#define NMEA_RMC_MAGNETIC_VARIATION       	10                
#define NMEA_RMC_MODE                     	11
//
//VTG
#define NMEA_VTG_HEADER                   	0
#define NMEA_VTG_COURSE_OVER_GROUND       	1
#define NMEA_VTG_REFERENCE_TRUE           	2
#define NMEA_VTG_COURSE_MAGNETIC          	3
#define NMEA_VTG_REFERENCE_MAGNETIC       	4
#define NMEA_VTG_SPEED_KNOTS              	5
#define NMEA_VTG_UNITS_KNOTS              	6
#define NMEA_VTG_SPEED_OVER_GROUND        	7
#define NMEA_VTG_UNITS_KM_H               	8
#define NMEA_VTG_MODE                     	9
//
//ZDA
#define NMEA_ZDA_HEADER                   	0
#define NMEA_ZDA_UTC_TIME                 	1
#define NMEA_ZDA_DAY                      	2
#define NMEA_ZDA_MONTH                    	3
#define NMEA_ZDA_YEAR                     	4
#define NMEA_ZDA_LOCAL_ZONE_HOUR          	5
#define NMEA_ZDA_LOCAL_ZONE_MINUTES      	6
//
#define NMEA_CARRIAGE_RETURN   				0x0D
#define NMEA_NEW_LINE          				0x0A
//
typedef struct _nmea_gps_satellite
{
	char PRN_Code[4];
	char Elevation[4];
	char Azimuth[4];
	char SNR[4];
} NMEA_GPS_SATELLITE;
//
typedef struct _nmea_gps_info
{
	char UTC_Date[15];
	char UTC_Time[15];
	char LocalTime[15];
	char Latitude[11];
	char Longitude[11];
	char Altitude[10];
	char AltitudeUnits[4];
	char Satellite[3];
	char Mode[11];
	char Pdop[5];
	char Hdop[5];
	char Vdop[5];
	char Speed[5];
	char TrueCourse[5];
	char MagneticCourse[5];
	char Quality[5];
	char N_S_Indicator[6];
	char E_W_Indicator[6];
	char Status[10];
	char TypeOperate[10];
	char Mode3D[10];
} NMEA_GPS_INFO;
//
extern NMEA_GPS_INFO 		NMEA_GPS_Info;
extern NMEA_GPS_SATELLITE 	NMEA_GPS_Satellites[NMEA_MAX_SATTELITE];
//
#define NMEA_GPS_PARSER_BUFFER_LEN		96
//
typedef struct _nmea_gps_parser_context
{
	unsigned char 	cmd;
	unsigned char 	ndx;
	char	buffer[NMEA_GPS_PARSER_BUFFER_LEN];
	
} NMEA_GPS_PARSER_CONTEXT;
//
void  	NMEA_InitContext();
unsigned char 	NMEA_Process(unsigned char byte);
unsigned char 	NMEA_IsDataOk(char *data);
unsigned char   NMEA_ParsingMessages(char *data);
void 	NMEA_GGA_Parsing();
void 	NMEA_RMC_Parsing();
void 	NMEA_GLL_Parsing();
void 	NMEA_GSA_Parsing();
void 	NMEA_GSV_Parsing();
void 	NMEA_VTG_Parsing();
void 	NMEA_ZDA_Parsing();
void 	NMEA_ClearData();
unsigned char 	NMEA_HexStrToInt(register unsigned char *data, unsigned char length);
float	NMEA_ConvertLat();
float	NMEA_ConvertLong();
float	NMEA_ConvertAlt();
NMEA_GPS_INFO * NMEA_GetGpsData();
//
#endif
/*EOF*/
