/***************************************************************************
;
;    This module is part of the BiPOM developer image for CloudGate Monnit
;    support. All the information in this source file and other source files
;    in the same developer image are copyrighted property of BiPOM Electronics.
;    The source files and the contained information in the source files are
;    confidential and should not be disclosed to anybody other than BiPOM,
;    Option and Monnit software developers, and only to those that have a need to
;    know.
;
;    BiPOM Electronics disclaims all warranties, express or implied warranties
;    of merchantability and fitness for a particular purpose. In no event shall
;    BiPOM Electronics be liable for any indirect, special, incidental or
;    consequential damages in connection  with or arising from the use of this
;    program.
;
;    Please e-mail any questions and suggestions to tech@bipom.com
;
***************************************************************************/

#ifndef _BIPOM_SERIAL_PORT_
#define _BIPOM_SERIAL_PORT_

#ifdef __cplusplus
extern "C"{
#endif 

	/***************************************************************************/
	#define SP_CLOSED	0
	#define SP_OPENED	1

	/***************************************************************************/
	typedef struct _serial_port
	{
		int		hPort;
		int		ReadTimeout;
		int		WriteTimeout;

	} SerialPort;

	/***************************************************************************/
	int SP_Init(SerialPort *pSerialPort);
	int SP_Open(SerialPort *pSerialPort, char *portName, int baudrate, int useRtsCts);
	int SP_Close(SerialPort *pSerialPort);
	
	int SP_GetBaudrateValue(int baudrate);
	int SP_SetTimeouts(SerialPort *pSerialPort, int readTimeout, int writeTimeout);
	int SP_SetControlLines(SerialPort *pSerialPort, int state);
	int SP_GetControlLines(SerialPort *pSerialPort, int *pState);
	int SP_IsOpened(SerialPort *pSerialPort);

	int SP_Read(SerialPort *pSerialPort, char *buffer, int count, int *pReadCount);
	int SP_Write(SerialPort *pSerialPort, char *buffer, int count, int offset, int *pWrittenCount);
	int SP_WriteCts(SerialPort *pSerialPort, char *buffer, int count, int offset, int *pWrittenCount);

#ifdef __cplusplus
}
#endif

#endif