/***************************************************************************
;
;    This module is part of the BiPOM developer image for CloudGate Monnit
;    support. All the information in this source file and other source files
;    in the same developer image are copyrighted property of BiPOM Electronics.
;    The source files and the contained information in the source files are
;    confidential and should not be disclosed to anybody other than BiPOM,
;    Option and Monnit software developers, and only to those that have a need to
;    know.
;
;    BiPOM Electronics disclaims all warranties, express or implied warranties
;    of merchantability and fitness for a particular purpose. In no event shall
;    BiPOM Electronics be liable for any indirect, special, incidental or
;    consequential damages in connection  with or arising from the use of this
;    program.
;
;    Please e-mail any questions and suggestions to tech@bipom.com
;
***************************************************************************/

#ifndef _SmtpClient_H_
#define _SmtpClient_H_

#include "tcp_socket.h"

// ***********************************************************************************************/
#define SMTP_XPRIORITY_HIGH 		2
#define SMTP_XPRIORITY_NORMAL 		3
#define SMTP_XPRIORITY_LOW 			4

// ***********************************************************************************************/
#define SMTP_IP_ADDR_LEN 			16
#define SMTP_LOGIN_LEN				64
#define SMTP_PASSWORD_LEN			64
#define SMTP_HOST_NAME_LEN 			64
#define SMTP_XMAILER_LEN 			64
#define SMTP_REPLYTO_LEN 			64
#define SMTP_MAIL_ADDR_LEN 			64
#define SMTP_NAME_LEN 				64
#define SMTP_SUBJECT_LEN 			64
#define SMTP_BODY_LEN 				1024
#define SMTP_BUFFER_LEN				1024
#define SMTP_ENC_LOGIN_PASSW_LEN	96

#define SMTP_RECIPIENT_COUNT		10

// ***********************************************************************************************/
typedef struct _SmtpClient_client  
{
	TcpSocket	*pSocket;

	char 	LocalHostName[SMTP_HOST_NAME_LEN];
	char	XMailer[SMTP_XMAILER_LEN];
	char	ReplyTo[SMTP_REPLYTO_LEN];
	char	XPriority;

	char	MailFrom[SMTP_MAIL_ADDR_LEN];
	char	NameFrom[SMTP_NAME_LEN];

	char	RecipientMail[SMTP_RECIPIENT_COUNT][SMTP_MAIL_ADDR_LEN];
	char	RecipientName[SMTP_RECIPIENT_COUNT][SMTP_NAME_LEN];
	char	CCRecipientMail[SMTP_RECIPIENT_COUNT][SMTP_MAIL_ADDR_LEN];
	char	CCRecipientName[SMTP_RECIPIENT_COUNT][SMTP_NAME_LEN];
	char	BCCRecipientMail[SMTP_RECIPIENT_COUNT][SMTP_MAIL_ADDR_LEN];
	char	BCCRecipientName[SMTP_RECIPIENT_COUNT][SMTP_NAME_LEN];

	int		_RecipientMailCount;
	int		_CCRecipientMailCount;
	int		_BCCRecipientMailCount;

	char	Subject[SMTP_SUBJECT_LEN];
	char	Body[SMTP_BODY_LEN];
	
	char	Login[SMTP_LOGIN_LEN];
	char	Password[SMTP_PASSWORD_LEN];
	
	char	Buffer[SMTP_BUFFER_LEN];
	
} SmtpClient;


// ***********************************************************************************************/
int SMTP_Init(SmtpClient *pSmtp, TcpSocket *pSocket);
int SMTP_AddRecipintMailAddr(SmtpClient *pSmtp, const char *pEmailAddr, const char *pName);
int SMTP_AddCCRecipintMailAddr(SmtpClient *pSmtp, const char *pEmailAddr, const char *pName);
int SMTP_AddBCCRecipintMailAddr(SmtpClient *pSmtp, const char *pEmailAddr, const char *pName);
int SMTP_Send(SmtpClient *pSmtp);

// ***********************************************************************************************/
int SMTP_RecieveHelloMsg(SmtpClient *pSmtp);
int SMTP_SendEhloCmd(SmtpClient *pSmtp);
int SMTP_SendAuthLoginCmd(SmtpClient *pSmtp);
int SMTP_SendAuthLogin(SmtpClient *pSmtp);
int SMTP_SendAuthPassword(SmtpClient *pSmtp);
int SMTP_SendMailFrom(SmtpClient *pSmtp);
int SMTP_SendReciepients(SmtpClient *pSmtp);
int SMTP_SendReciepients(SmtpClient *pSmtp);
int SMTP_SendDataCmd(SmtpClient *pSmtp);
int SMTP_SendEmailHeaders(SmtpClient *pSmtp);
int SMTP_SendEmailBody(SmtpClient *pSmtp);
int SMTP_SendEmailCloseSequence(SmtpClient *pSmtp);
int SMTP_SendQuitCmd(SmtpClient *pSmtp);

int SMTP_GetStatusCode(SmtpClient *pSmtp);
int SMTP_ReceiveLine(SmtpClient *pSmtp);
int SMTP_SendData(SmtpClient *pSmtp);

#endif
