/***************************************************************************
;
;    This module is part of the BiPOM developer image for CloudGate Monnit
;    support. All the information in this source file and other source files
;    in the same developer image are copyrighted property of BiPOM Electronics.
;    The source files and the contained information in the source files are
;    confidential and should not be disclosed to anybody other than BiPOM,
;    Option and Monnit software developers, and only to those that have a need to
;    know.
;
;    BiPOM Electronics disclaims all warranties, express or implied warranties
;    of merchantability and fitness for a particular purpose. In no event shall
;    BiPOM Electronics be liable for any indirect, special, incidental or
;    consequential damages in connection  with or arising from the use of this
;    program.
;
;    Please e-mail any questions and suggestions to tech@bipom.com
;
***************************************************************************/

#ifndef _BIPOM_SSL_
#define _BIPOM_SSL_

#include <openssl/ssl.h>
#include <openssl/err.h>

#include "tcp_socket.h"

#ifdef __cplusplus
extern "C"{
#endif 

	/***************************************************************************/
	typedef struct _ssl
	{
		SSL_CTX		*pSslContext;
		SSL			*pSslConnection;

	} Ssl;

	/***************************************************************************/
	int SSL_Init();
	int SSL_InitContext(Ssl *pSsl);
	int SSL_FreeContext(Ssl *pSsl);
	int SSL_CreateConnection(Ssl *pSsl);
	int SSL_AttachSocket(Ssl *pSsl, TcpSocket *pSocket);
	
	int SSL_Read(Ssl *pSsl, char *pData, int length);
	int SSL_Write(Ssl *pSsl, char *pData, int length);

	int SSL_LogCert(Ssl *pSsl);

#ifdef __cplusplus
}
#endif

#endif
