/***************************************************************************
;
;    This module is part of the BiPOM developer image for CloudGate Monnit
;    support. All the information in this source file and other source files
;    in the same developer image are copyrighted property of BiPOM Electronics.
;    The source files and the contained information in the source files are
;    confidential and should not be disclosed to anybody other than BiPOM,
;    Option and Monnit software developers, and only to those that have a need to
;    know.
;
;    BiPOM Electronics disclaims all warranties, express or implied warranties
;    of merchantability and fitness for a particular purpose. In no event shall
;    BiPOM Electronics be liable for any indirect, special, incidental or
;    consequential damages in connection  with or arising from the use of this
;    program.
;
;    Please e-mail any questions and suggestions to tech@bipom.com
;
***************************************************************************/

#ifndef _BIPOM_TCP_SERVER_H_
#define _BIPOM_TCP_SERVER_H_

#include "tcp_socket.h"
#include "thread.h"

#ifdef __cplusplus
extern "C"{
#endif 
		
/***************************************************************************/
typedef int(*pTcpServerFunc)(int *pStopRequest, TcpSocket *pSocket);

#define TCP_SRV_DEFAULT_PORT		8080
#define TCP_SRV_INADDR_ANY			"0.0.0.0"
#define TCP_SRV_MAX_ADDR_LEN		256

/***************************************************************************/
typedef struct _bipom_tcp_server
{
	TcpSocket		ListenSocket;
	Thread			Task;

	char			IPAddr[TCP_SRV_MAX_ADDR_LEN];
	int				Port;
	pTcpServerFunc	TcpServerFunc;

	int				StopRequested;

	int				ReadTimeout;

} TcpServer;

/***************************************************************************/
void TCPSRV_Init(TcpServer *pTcpServer, char *pIPAddr, int Port, pTcpServerFunc tcpServerFunc);
void TCPSRV_Init2(TcpServer *pTcpServer, char *pIPAddr, int Port, pTcpServerFunc tcpServerFunc, int readTimeout);
void TCPSRV_SetDefaults(TcpServer *pTcpServer);
int  TCPSRV_OpenListenSocket(TcpServer *pTcpServer);

int TCPSRV_Start(TcpServer *pTcpServer);
int TCPSRV_Stop(TcpServer *pTcpServer);

int TCPSRV_Task(int *pStopRequest, void *pParams);

#ifdef __cplusplus
}
#endif

#endif
