/***************************************************************************
;
;    This module is part of the BiPOM developer image for CloudGate Monnit
;    support. All the information in this source file and other source files
;    in the same developer image are copyrighted property of BiPOM Electronics.
;    The source files and the contained information in the source files are
;    confidential and should not be disclosed to anybody other than BiPOM,
;    Option and Monnit software developers, and only to those that have a need to
;    know.
;
;    BiPOM Electronics disclaims all warranties, express or implied warranties
;    of merchantability and fitness for a particular purpose. In no event shall
;    BiPOM Electronics be liable for any indirect, special, incidental or
;    consequential damages in connection  with or arising from the use of this
;    program.
;
;    Please e-mail any questions and suggestions to tech@bipom.com
;
***************************************************************************/

#ifndef _BIPOM_TCP_SOCKET_H_
#define _BIPOM_TCP_SOCKET_H_

#ifdef __cplusplus
extern "C"{
#endif 

	/***************************************************************************/
	#define BIPOM_TCP_MAX_BUFFER_SIZE		8192

	/***************************************************************************/
	typedef struct _tcp_socket
	{
		int Socket;
		int ReadTimeoutInSeconds;
		int ConnectTimeoutInSeconds;

	} TcpSocket;


	/***************************************************************************/
	int SOCK_Init(TcpSocket *pSocket);
	int SOCK_Open(TcpSocket *pSocket);
	int SOCK_Close(TcpSocket *pSocket);

	int SOCK_IsOpened(TcpSocket *pSocket);
	int SOCK_IsConnected(TcpSocket *pSocket);
	int SOCK_IsReadable(TcpSocket *pSocket);
	int SOCK_GetBytesAwait(TcpSocket *pSocket, int *pCount);

	int SOCK_GetReadTimeout(TcpSocket *pSocket);
	int SOCK_SetReadTimeout(TcpSocket *pSocket, int TimeoutInSeconds);
	int SOCK_GetConnectTimeout(TcpSocket *pSocket);
	int SOCK_SetConnectTimeout(TcpSocket *pSocket, int TimeoutInSeconds);

	int SOCK_SetReuseAddr(TcpSocket *pSocket, int Enabled);
	int SOCK_SetNonBlocking(TcpSocket *pSocket, int Enabled);

	int SOCK_Connect(TcpSocket *pSocket, const char *pAddr, int Port);
	int SOCK_Bind(TcpSocket *pSocket, const char *pIPAddr, int Port);
	int SOCK_Listen(TcpSocket *pSocket, int MaxConn);
	int SOCK_Accept(TcpSocket *pSocket);

	int SOCK_Read(TcpSocket *pSocket, char *pData, int Len);
	int SOCK_Write(TcpSocket *pSocket, char *pData, int Len);


#ifdef __cplusplus
}
#endif

#endif