/***************************************************************************
;
;    This module is part of the BiPOM developer image for CloudGate Monnit
;    support. All the information in this source file and other source files
;    in the same developer image are copyrighted property of BiPOM Electronics.
;    The source files and the contained information in the source files are
;    confidential and should not be disclosed to anybody other than BiPOM,
;    Option and Monnit software developers, and only to those that have a need to
;    know.
;
;    BiPOM Electronics disclaims all warranties, express or implied warranties
;    of merchantability and fitness for a particular purpose. In no event shall
;    BiPOM Electronics be liable for any indirect, special, incidental or
;    consequential damages in connection  with or arising from the use of this
;    program.
;
;    Please e-mail any questions and suggestions to tech@bipom.com
;
***************************************************************************/

#ifndef _BIPOM_UTILS_
#define _BIPOM_UTILS_

#include <sys/stat.h>
#include <time.h>

#ifdef __cplusplus
extern "C"{
#endif 

#define WRTU_MAX_PATH			512
#define WRTU_MAX_FILENAME		128

#define WRTU_GUID_LEN			36

void RTrim(char *pSrc);
void LTrim(char *pSrc);
void Trim(char *pSrc);
void SplitLine(char * pLine, char separator, char *pLeftPart, char *pRightPart);
void StrReplace(char *s, char oldSym, char newSym);

void SleepMs(int milliseconds);
void CurTimeToFileName(char *pFilename, int maxLength, char * suffix);
void CurDateToFileName(char *pFilename, int maxLength, char * suffix);

struct timespec TimeDiff(struct timespec start, struct timespec end);

void GenGUID(char *pGUID, int maxLength);
unsigned long Mix(unsigned long a, unsigned long b, unsigned long c);

void DwordToByteArray(unsigned int dword, unsigned char* pByte);
unsigned int DwordFromByteArray(unsigned char* pByte);

unsigned int Crc16(unsigned char  *pData, unsigned int length);
unsigned int Crc16V1(unsigned char  *pData, int size, int length);

void PrintBinary(unsigned char *buffer, int size);
int BufferToString(unsigned char *pData, int len, char *pDestStr);

int CreateDirIfNotExists(char *pDirPath, mode_t Mode);
int IsDirExists(char *pDirPath);
long GetFileSize(const char *pFilePath);
int IsFileExists(const char *pFilePath);

unsigned long GetDirSize(const char *pDirPath);
int GetUtcOffset();

int kbhit();

char *int2binstr(int value, char *buffer, int bits, int padSize);

#ifdef __cplusplus
}
#endif

#endif