/***************************************************************************
;
;    This module is part of the BiPOM developer image for CloudGate Monnit
;    support. All the information in this source file and other source files
;    in the same developer image are copyrighted property of BiPOM Electronics.
;    The source files and the contained information in the source files are
;    confidential and should not be disclosed to anybody other than BiPOM,
;    Option and Monnit software developers, and only to those that have a need to
;    know.
;
;    BiPOM Electronics disclaims all warranties, express or implied warranties
;    of merchantability and fitness for a particular purpose. In no event shall
;    BiPOM Electronics be liable for any indirect, special, incidental or
;    consequential damages in connection  with or arising from the use of this
;    program.
;
;    Please e-mail any questions and suggestions to tech@bipom.com
;
***************************************************************************/

#ifndef _BIPOM_WRTU_EVENT_INFO_
#define _BIPOM_WRTU_EVENT_INFO_

#ifdef __cplusplus
extern "C"{
#endif 

//*********************************************************************************************
#define WRTU_EVENT_TYPE_ERROR						0
#define WRTU_EVENT_TYPE_WARNING						1
#define WRTU_EVENT_TYPE_INFORMATION					2
#define WRTU_EVENT_TYPE_ALARM						3
#define WRTU_EVENT_TYPE_COUNT						4

//*********************************************************************************************
#define WRTU_EVENT_NONE								0
#define WRTU_EVENT_START							1
#define WRTU_EVENT_DS_INIT_FAILED					2
#define WRTU_EVENT_INIT_UART2_DRV					3
#define WRTU_EVENT_INIT_RS485_DRV					4
#define WRTU_EVENT_INIT_UART0_DRV					5
#define WRTU_EVENT_INIT_DIO							6
#define WRTU_EVENT_INIT_ADC							7
#define WRTU_EVENT_INIT_DISPLAY						8
#define WRTU_EVENT_PROTO_SAVE_CFG_FAILED			15
#define WRTU_EVENT_INIT_USB_DRV						16
#define WRTU_EVENT_ADD_TAG							17
#define WRTU_EVENT_UPDATE_TAG						18
#define WRTU_EVENT_LOAD_TAG							19
#define WRTU_EVENT_INIT_UART2						20
#define WRTU_EVENT_INIT_UART3						21
#define WRTU_EVENT_INIT_TLC2543						22
#define WRTU_EVENT_ADD_CONTACT						23
#define WRTU_EVENT_LOAD_CONTACTS_FAILED				24
#define WRTU_EVENT_LOAD_CONFIG_FAILED				25
#define WRTU_EVENT_LOAD_TAGS_FAILED					26
#define WRTU_EVENT_PROTO_SAVE_TAGS_FAILED			27
#define WRTU_EVENT_ADD_MESSAGE						28
#define WRTU_EVENT_LOAD_MESSAGES_FAILED				29
#define WRTU_EVENT_PROTO_SAVE_MESSAGE_FAILED		30
#define WRTU_EVENT_LOAD_TAG_FAILED					31
#define WRTU_EVENT_DS_CFG_DEVICE					34
#define WRTU_EVENT_DS_LOG_DEVICE					35
#define WRTU_EVENT_SMS_SENT_FAILED					36
#define WRTU_EVENT_SMS_SENT_SUCCESS					37
#define WRTU_EVENT_DI_CNT_INIT_FAILED				38
#define WRTU_EVENT_DI_CNT_START_FAILED				39
#define WRTU_EVENT_DI_CNT_STOP_FAILED				40
#define WRTU_EVENT_EMAIL_SENT_FAILED				42
#define WRTU_EVENT_EMAIL_SENT_SUCCESS				43

#define WRTU_EVENT_LOAD_DEVICE_CONFIG_FAILED		44
#define WRTU_EVENT_LOAD_CELL_CONFIG_FAILED			45
#define WRTU_EVENT_LOAD_PERIPH_CONFIG_FAILED		46
#define WRTU_EVENT_LOAD_PUSHING_DATA_CONFIG_FAILED	47
#define WRTU_EVENT_LOAD_SMTP_CONFIG_FAILED			48
#define WRTU_EVENT_LOAD_COUNTERS_CONFIG_FAILED		49

// cell related events
#define WRTU_EVENT_CELL_OPEN						9
#define WRTU_EVENT_CELL_CLOSE						10
#define WRTU_EVENT_CELL_START_SERVER				12
#define WRTU_EVENT_CELL_STOP_SERVER					13
#define WRTU_EVENT_CELL_ENABLED						32
#define WRTU_EVENT_CELL_DISABLED					33
#define WRTU_EVENT_CELL_DETECT						41

#define WRTU_EVENT_CELL_REINIT_MODEM				50
#define WRTU_EVENT_CELL_MODEM_MODEL					51
#define WRTU_EVENT_CELL_READ_TIMEOUT				52
#define WRTU_EVENT_CELL_STOP_CLIENT					53
#define WRTU_EVENT_CELL_START_CLIENT				54
#define WRTU_EVENT_CELL_CONN_CLOSED_BY_PEER			55
#define WRTU_EVENT_CELL_TEST_INCOMING_CONN_FAILED	56
#define WRTU_EVENT_CELL_OPEN_TCP_SERVER				58
#define WRTU_EVENT_CELL_NET_STATUS					59
#define WRTU_EVENT_CELL_READ_NET_STATUS				60
#define WRTU_EVENT_CELL_REG_STATUS					61
#define WRTU_EVENT_CELL_READ_REG_STATUS				62
#define WRTU_EVENT_CELL_SIM_ERROR					63
#define WRTU_EVENT_CELL_SIM_STATUS					64
#define WRTU_EVENT_CELL_READ_SIM_STATUS				65
#define WRTU_EVENT_CELL_CSQ_DBM_LEVEL				66
#define WRTU_EVENT_CELL_CSQ_RAW_LEVEL				67
#define WRTU_EVENT_CELL_READ_CSQ					68
#define WRTU_EVENT_CELL_CLOSE_GPRS					69
#define WRTU_EVENT_CELL_START_GPRS					70
#define WRTU_EVENT_CELL_CFG_GPRS					71
#define WRTU_EVENT_CELL_UPDATE_STATUS				72
#define WRTU_EVENT_CELL_MODEM_ERR_CODE				73
#define WRTU_EVENT_CELL_SOFTWARE_RESET				74
#define WRTU_EVENT_CELL_HARDWARE_RESET				75
#define WRTU_EVENT_CELL_WRITE_TIMEOUT				76
#define WRTU_EVENT_SMTP_ERR_CODE					77

#define WRTU_EVENT_SOFT_RESTART						78
#define WRTU_EVENT_FIRMWARE_REV						79

#define WRTU_EVENT_CELL_RESTORE_FROM_BINARY_MODE	83

#define WRTU_EVENT_DP_SUCCESS						80	
#define WRTU_EVENT_DP_SEND_ERR_CODE					81
#define WRTU_EVENT_DP_HTTP_STATUS_CODE				82
#define WRTU_EVENT_DP_READ_RESP_ERR_CODE			84
#define WRTU_EVENT_DP_RESP_ERR_CODE					85

#define WRTU_EVENT_PROTO_DELETE_TAG_FAILED			86

// Cloudgate Events
#define WRTU_EVENT_CG_STARTED						87
#define WRTU_EVENT_CG_3G_CONNECTED					88
#define WRTU_EVENT_CG_3G_DISCONNECTED				89


#endif
