/***************************************************************************
;
;    This module is part of the BiPOM developer image for CloudGate Monnit
;    support. All the information in this source file and other source files
;    in the same developer image are copyrighted property of BiPOM Electronics.
;    The source files and the contained information in the source files are
;    confidential and should not be disclosed to anybody other than BiPOM,
;    Option and Monnit software developers, and only to those that have a need to
;    know.
;
;    BiPOM Electronics disclaims all warranties, express or implied warranties
;    of merchantability and fitness for a particular purpose. In no event shall
;    BiPOM Electronics be liable for any indirect, special, incidental or
;    consequential damages in connection  with or arising from the use of this
;    program.
;
;    Please e-mail any questions and suggestions to tech@bipom.com
;
***************************************************************************/

#ifndef _BIPOM_WRTU_HARDWARE_INFO_
#define _BIPOM_WRTU_HARDWARE_INFO_

#ifdef __cplusplus
extern "C"{
#endif 

//***************************************************************************
// Hardware Status Bits
//***************************************************************************
#define HW_STATE_CORE		0
#define HW_STATE_UART0		1
#define HW_STATE_UART1		2
#define HW_STATE_UART2		3
#define HW_STATE_UART3		4
#define HW_STATE_USB		5
#define HW_STATE_IO			6
#define HW_STATE_ADC		7
#define HW_STATE_UART0_DRV	8
#define HW_STATE_RS485_DRV	9
#define HW_STATE_CELL_DRV	10
#define HW_STATE_USB_DRV	11
#define HW_STATE_DISPLAY	12
#define HW_STATE_TLC2543	13
#define HW_STATE_CELL_MODEM	14

#define HW_STATE_MAX_COUNT	15


//***************************************************************************
// TLC2543 Channels
//***************************************************************************
#define HW_TLC2543_FIRST_CHANNEL	0
#define HW_TLC2543_LAST_CHANNEL		0xA

//***************************************************************************
// WiPOM Hardware Description
//***************************************************************************
#define HW_WIPOM_ADC_FIRST_CHANNEL		0
#define HW_WIPOM_ADC_LAST_CHANNEL		10

#define HW_WIPOM_DI_FIRST_PIN			0
#define HW_WIPOM_DI_LAST_PIN			7

#define HW_WIPOM_DO_FIRST_PIN			0
#define HW_WIPOM_DO_LAST_PIN			7

//***************************************************************************
// NanoWiPOM Hardware Description
//***************************************************************************

#define HW_NANO_FREQ_COUNT				2
#define HW_NANO_FREQ_FIRST_CHANNEL		0
#define HW_NANO_FREQ_LAST_CHANNEL		1

#define HW_NANO_ADC_COUNT			    4
#define HW_NANO_ADC_FIRST_CHANNEL		0
#define HW_NANO_ADC_LAST_CHANNEL		3

#define HW_NANO_DI_COUNT				4
#define HW_NANO_DI_FIRST_PIN			0
#define HW_NANO_DI_LAST_PIN				3

#define HW_NANO_DO_COUNT				2
#define HW_NANO_DO_FIRST_PIN			1
#define HW_NANO_DO_LAST_PIN				2

#define HW_NANO_DI_CNT_CHANNEL_COUNT	4

	
#ifdef __cplusplus
}
#endif

#endif	